//===================================================================
//                                                                  =
// Author:    Martin Berriman                                       =
// Copyright: Innovatronics Ltd 2006                                =
//                                                                  =
//===================================================================

#ifndef _TIMERC
#define _TIMERC

// HEADERS ==========================================================
#include "timer.h"
// END HEADERS ======================================================

// C FILES ==========================================================
// END C FILES ======================================================

// MACROS =========================================================
// END MACROS =====================================================

// GLOBALS ==========================================================
//Timer setting: 20Meg / 4Clocks / (65536 - timer_val) = number of interrupts per second
//Want a timer val of 5000 (to give 1000 interrupts per second) so...
//int16 timer_val = 60536;
int16 timer_val = 60591;
static volatile unsigned int16	TimerCounter;
static volatile bool	TimerTicked;
// END GLOBALS ======================================================

//----------------------------------------------------------------------------------
//#INT_TIMER3 FAST //Timer 3 interrupt
#INT_TIMER3
void timer3_int(void)
//----------------------------------------------------------------------------------
{
	set_timer3(timer_val);

	if (TimerCounter != 0)
	{
		TimerCounter--;

		if (TimerCounter == 0)
		{
			TimerTicked = true;
		}
	}
}

//----------------------------------------------------------------------------------
void initialise_timer(void)
//----------------------------------------------------------------------------------
{
	disable_interrupts(INT_TIMER3);
	setup_timer_3(T3_INTERNAL | T3_DIV_BY_1);
	set_timer3(timer_val);
	TimerCounter = 1000;
	TimerTicked = false;
}

//----------------------------------------------------------------------------------
void run_timer(void)
//----------------------------------------------------------------------------------
{
	enable_interrupts(global);
	enable_interrupts(INT_TIMER3);
	enable_interrupts(int_rda);				//Allow RS232 interrupts
}

//----------------------------------------------------------------------------------
void halt_timer(void)
//----------------------------------------------------------------------------------
{
	disable_interrupts(INT_TIMER3);
}

//----------------------------------------------------------------------------------
void timer_restart(void)
//----------------------------------------------------------------------------------
{
	halt_timer();

	TimerCounter = 1000;
	TimerTicked = false;

	run_timer();
}

//-------------------------------------------------------------------
bool timer_has_ticked(void)
//-------------------------------------------------------------------
{
	bool ticked = false;

	halt_timer();

	ticked = TimerTicked;
	TimerTicked = false;

	run_timer();

	return ticked;
}


// =============================================================
#endif